import "core-js/modules/es.array.concat.js";

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React, { Component } from 'react';
import PropTypes from 'prop-types';
import debounce from 'lodash/debounce';
import Preview from 'rsg-components/Preview';
import Para from 'rsg-components/Para';
import Slot from 'rsg-components/Slot';
import PlaygroundRenderer from 'rsg-components/Playground/PlaygroundRenderer';
import Context from 'rsg-components/Context';
import { EXAMPLE_TAB_CODE_EDITOR } from '../slots';
import { DisplayModes, ExampleModes } from '../../consts';

var Playground = /*#__PURE__*/function (_Component) {
  _inheritsLoose(Playground, _Component);

  function Playground() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _Component.call.apply(_Component, [this].concat(args)) || this;

    _defineProperty(_assertThisInitialized(_this), "handleChange", debounce(function (code) {
      _this.setState({
        code: code
      });
    }, _this.context.config.previewDelay));

    _defineProperty(_assertThisInitialized(_this), "state", {
      code: _this.props.code,
      prevCode: _this.props.code,
      activeTab: _this.getInitialActiveTab() ? EXAMPLE_TAB_CODE_EDITOR : undefined
    });

    _defineProperty(_assertThisInitialized(_this), "handleTabChange", function (name) {
      _this.setState(function (state) {
        return {
          activeTab: state.activeTab !== name ? name : undefined
        };
      });
    });

    return _this;
  }

  Playground.getDerivedStateFromProps = function getDerivedStateFromProps(nextProps, prevState) {
    var code = nextProps.code;

    if (prevState.prevCode !== code) {
      return {
        prevCode: code,
        code: code
      };
    }

    return null;
  };

  var _proto = Playground.prototype;

  _proto.componentWillUnmount = function componentWillUnmount() {
    // Clear pending changes
    this.handleChange.cancel();
  };

  _proto.getInitialActiveTab = function getInitialActiveTab() {
    var showcode = this.props.modifiers.showcode;
    var expandCode = this.props.exampleMode === ExampleModes.expand;
    return showcode !== undefined ? showcode : expandCode;
  };

  _proto.render = function render() {
    var _this$state = this.state,
        code = _this$state.code,
        activeTab = _this$state.activeTab;
    var _this$props = this.props,
        documentScope = _this$props.documentScope,
        exampleScope = _this$props.exampleScope,
        componentName = _this$props.componentName,
        modifiers = _this$props.modifiers,
        exampleMode = _this$props.exampleMode;
    var displayMode = this.context.displayMode;
    var isExampleHidden = exampleMode === ExampleModes.hide;
    var isEditorHidden = modifiers.noeditor || isExampleHidden;
    var preview = /*#__PURE__*/React.createElement(Preview, {
      code: code,
      documentScope: documentScope,
      exampleScope: exampleScope
    });
    return isEditorHidden ? /*#__PURE__*/React.createElement(Para, null, preview) : /*#__PURE__*/React.createElement(PlaygroundRenderer, {
      componentName: componentName,
      exampleIndex: modifiers.index,
      padded: !!modifiers.padded,
      preview: preview,
      previewClassName: modifiers['preview-class'],
      tabButtons: /*#__PURE__*/React.createElement(Slot, {
        name: "exampleTabButtons",
        active: activeTab,
        props: {
          onClick: this.handleTabChange
        }
      }),
      tabBody: /*#__PURE__*/React.createElement(Slot, {
        name: "exampleTabs",
        active: activeTab,
        onlyActive: true,
        props: {
          code: code,
          onChange: this.handleChange
        }
      }),
      toolbar: /*#__PURE__*/React.createElement(Slot, {
        name: "exampleToolbar",
        props: {
          name: componentName,
          isolated: displayMode === DisplayModes.example,
          exampleIndex: modifiers.index
        }
      })
    });
  };

  return Playground;
}(Component);

_defineProperty(Playground, "propTypes", {
  code: PropTypes.string.isRequired,
  documentScope: PropTypes.object.isRequired,
  exampleScope: PropTypes.object.isRequired,
  componentName: PropTypes.string.isRequired,
  exampleMode: PropTypes.string.isRequired,
  modifiers: PropTypes.object.isRequired
});

_defineProperty(Playground, "contextType", Context);

export default Playground;