function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import "core-js/modules/es.function.name.js";
import "core-js/modules/es.symbol.js";
import "core-js/modules/es.symbol.description.js";
import "core-js/modules/es.object.assign.js";
import React, { useState } from 'react';
import PropTypes from 'prop-types';
import Examples from 'rsg-components/Examples';
import SectionHeading from 'rsg-components/SectionHeading';
import JsDoc from 'rsg-components/JsDoc';
import Markdown from 'rsg-components/Markdown';
import Slot from 'rsg-components/Slot';
import ReactComponentRenderer from 'rsg-components/ReactComponent/ReactComponentRenderer';
import { useStyleGuideContext } from 'rsg-components/Context';
import ExamplePlaceholderDefault from 'rsg-components/ExamplePlaceholder';
import MdxWrapper from 'rsg-components/mdx/MdxWrapper';
import MdxCode from 'rsg-components/mdx/MdxCode';
import { DOCS_TAB_USAGE } from '../slots';
import { DisplayModes, UsageModes } from '../../consts';
var ExamplePlaceholder = process.env.STYLEGUIDIST_ENV !== 'production' ? ExamplePlaceholderDefault : function () {
  return /*#__PURE__*/React.createElement("div", null);
};
export default function ReactComponent(props) {
  var _useState = useState(function () {
    return props.usageMode === UsageModes.expand ? DOCS_TAB_USAGE : undefined;
  }),
      activeTab = _useState[0],
      setActiveTab = _useState[1];

  var _useStyleGuideContext = useStyleGuideContext(),
      displayMode = _useStyleGuideContext.displayMode,
      targetIndex = _useStyleGuideContext.targetIndex,
      pagePerSection = _useStyleGuideContext.config.pagePerSection;

  var component = props.component,
      depth = props.depth,
      usageMode = props.usageMode,
      exampleMode = props.exampleMode;
  var componentName = component.name,
      visibleName = component.visibleName,
      _component$slug = component.slug,
      slug = _component$slug === void 0 ? '-' : _component$slug,
      filepath = component.filepath,
      pathLine = component.pathLine,
      href = component.href;

  var _ref = component.props || {},
      _ref$description = _ref.description,
      description = _ref$description === void 0 ? '' : _ref$description,
      content = _ref.content,
      _ref$tags = _ref.tags,
      tags = _ref$tags === void 0 ? {} : _ref$tags;

  var _ref2 = content || {},
      _ref2$__examples = _ref2.__examples,
      examples = _ref2$__examples === void 0 ? [] : _ref2$__examples,
      _ref2$__namedExamples = _ref2.__namedExamples,
      namedExamples = _ref2$__namedExamples === void 0 ? {} : _ref2$__namedExamples;

  if (!componentName) {
    return null;
  }

  var showUsage = usageMode !== UsageModes.hide;

  var handleTabChange = function handleTabChange(tabName) {
    setActiveTab(function (currentActiveTab) {
      return currentActiveTab !== tabName ? tabName : undefined;
    });
  };

  function getExamples() {
    // Isolated mode: fenced code block example
    if (typeof targetIndex === 'number' && examples[targetIndex] && content) {
      var example = examples[targetIndex];
      return /*#__PURE__*/React.createElement(MdxWrapper, _extends({
        componentName: componentName,
        exampleMode: exampleMode
      }, content), /*#__PURE__*/React.createElement(MdxCode, _extends({
        className: "language-" + example.lang
      }, example.settings), example.content));
    } // Isolated mode: named story imported from a CSF file


    if (typeof targetIndex === 'string' && namedExamples[targetIndex] && content) {
      var _example = namedExamples[targetIndex];
      return /*#__PURE__*/React.createElement(MdxWrapper, _extends({
        componentName: componentName,
        exampleMode: exampleMode
      }, content), /*#__PURE__*/React.createElement(MdxCode, {
        index: targetIndex,
        className: "language-jsx"
      }, _example));
    } // Static code


    if (content) {
      return /*#__PURE__*/React.createElement(Examples, {
        content: content,
        componentName: componentName,
        exampleMode: exampleMode
      });
    }

    return /*#__PURE__*/React.createElement(ExamplePlaceholder, {
      name: componentName
    });
  }

  return /*#__PURE__*/React.createElement(ReactComponentRenderer, {
    componentName: componentName,
    slug: slug,
    filepath: filepath,
    pathLine: pathLine,
    docs: /*#__PURE__*/React.createElement(JsDoc, tags),
    description: description && /*#__PURE__*/React.createElement(Markdown, {
      text: description
    }),
    heading: /*#__PURE__*/React.createElement(SectionHeading, {
      id: slug,
      pagePerSection: pagePerSection,
      deprecated: !!tags.deprecated,
      slotName: "componentToolbar",
      slotProps: Object.assign({}, component, {
        isolated: displayMode !== DisplayModes.all
      }),
      href: href,
      depth: depth
    }, visibleName),
    examples: getExamples(),
    tabButtons: showUsage && /*#__PURE__*/React.createElement(Slot, {
      name: "docsTabButtons",
      active: activeTab,
      props: Object.assign({}, component, {
        onClick: handleTabChange
      })
    }),
    tabBody: /*#__PURE__*/React.createElement(Slot, {
      name: "docsTabs",
      active: activeTab,
      onlyActive: true,
      props: component
    })
  });
}
ReactComponent.propTypes = {
  component: PropTypes.object.isRequired,
  depth: PropTypes.number.isRequired,
  exampleMode: PropTypes.string.isRequired,
  usageMode: PropTypes.string.isRequired
};