import React from 'react';
import PropTypes from 'prop-types';
import Wrapper from 'rsg-components/Wrapper';
import evalInContext from '../../utils/evalInContext';
import compileCode from '../../utils/compileCode';
export default function ReactExample(_ref) {
  var onError = _ref.onError,
      code = _ref.code,
      documentScope = _ref.documentScope,
      exampleScope = _ref.exampleScope,
      compileExample = _ref.compileExample;
  var compiledCode = compileCode(code, compileExample, onError);
  var ExampleComponent = evalInContext(compiledCode, {
    documentScope: documentScope,
    exampleScope: exampleScope
  });
  return /*#__PURE__*/React.createElement(Wrapper, {
    onError: onError
  }, /*#__PURE__*/React.createElement(ExampleComponent, null));
}
ReactExample.propTypes = {
  code: PropTypes.string.isRequired,
  documentScope: PropTypes.object.isRequired,
  exampleScope: PropTypes.object.isRequired,
  compileExample: PropTypes.func.isRequired,
  onError: PropTypes.func.isRequired
};