import "core-js/modules/es.object.keys.js";

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React from 'react';
import Playground from 'rsg-components/Playground';
import { useMdxContext } from './MdxContext';
import MdxHighlight from './MdxHighlight';
import MdxCodeStatic from './MdxCodeStatic';
export default function MdxCode(_ref) {
  var className = _ref.className,
      children = _ref.children,
      modifiers = _objectWithoutPropertiesLoose(_ref, ["className", "children"]);

  var _useMdxContext = useMdxContext(),
      componentName = _useMdxContext.componentName,
      exampleMode = _useMdxContext.exampleMode,
      documentScope = _useMdxContext.documentScope,
      exampleScope = _useMdxContext.exampleScope;

  if (modifiers.static) {
    return /*#__PURE__*/React.createElement(MdxCodeStatic, null, /*#__PURE__*/React.createElement(MdxHighlight, {
      className: className
    }, children));
  }

  return /*#__PURE__*/React.createElement(Playground, {
    code: String(children),
    componentName: componentName || '' // TODO
    ,
    exampleMode: exampleMode,
    documentScope: documentScope,
    exampleScope: exampleScope,
    modifiers: modifiers
  });
}