function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import "core-js/modules/es.string.replace.js";
import "core-js/modules/es.regexp.exec.js";
import "core-js/modules/es.array.map.js";
import "core-js/modules/es.object.assign.js";
import React from 'react';
import Highlight, { defaultProps } from 'prism-react-renderer';
import useTheme from '../../styles/useTheme';
import prismTheme from '../../styles/prismTheme';
import MdxHighlightPre from './MdxHighlightPre';
export default function MdxHighlight(_ref) {
  var children = _ref.children,
      codeClassName = _ref.className;
  var theme = useTheme();

  if (!codeClassName) {
    return /*#__PURE__*/React.createElement(MdxHighlightPre, null, children);
  } // Mdx uses `language-js` class names, markdown-to-jsx — `lang-js`


  var language = codeClassName.replace(/lang(uage)?-/, '');
  return /*#__PURE__*/React.createElement(Highlight, _extends({}, defaultProps, {
    theme: prismTheme(theme),
    code: children,
    language: language
  }), function (_ref2) {
    var className = _ref2.className,
        style = _ref2.style,
        tokens = _ref2.tokens,
        getLineProps = _ref2.getLineProps,
        getTokenProps = _ref2.getTokenProps;
    return /*#__PURE__*/React.createElement(MdxHighlightPre, {
      className: className,
      style: style
    }, tokens.map(function (line, index) {
      return /*#__PURE__*/React.createElement("div", _extends({
        key: index
      }, getLineProps({
        line: line,
        key: index
      })), line.map(function (token, key) {
        return /*#__PURE__*/React.createElement("span", _extends({
          key: key
        }, getTokenProps({
          token: token,
          key: key
        })));
      }));
    }));
  });
}