import "core-js/modules/es.string.small.js";
import React from 'react';
import PropTypes from 'prop-types';
import cx from 'clsx';
import Styled from 'rsg-components/Styled';

var styles = function styles(_ref) {
  var fontSize = _ref.fontSize,
      fontFamily = _ref.fontFamily;
  return {
    highlightPre: {
      margin: 0,
      fontFamily: fontFamily.monospace,
      fontSize: fontSize.small,
      lineHeight: 1.5,
      whiteSpace: 'pre-wrap',
      wordWrap: 'normal',
      tabSize: 2,
      hyphens: 'none',
      overflow: 'auto',
      // react-simple-code-editor sets ponter-events: none on the container,
      // we need to reapply it here
      pointerEvents: 'inherit'
    }
  };
};

export var MdxHighlightPre = function MdxHighlightPre(_ref2) {
  var classes = _ref2.classes,
      className = _ref2.className,
      style = _ref2.style,
      children = _ref2.children;
  var classNames = cx(className, classes.highlightPre);
  return /*#__PURE__*/React.createElement("pre", {
    className: classNames,
    style: style
  }, children);
};
MdxHighlightPre.propTypes = {
  classes: PropTypes.objectOf(PropTypes.string.isRequired).isRequired,
  className: PropTypes.string,
  children: PropTypes.node
};
export default Styled(styles)(MdxHighlightPre);