import React from 'react';
import PropTypes from 'prop-types';
import cx from 'clsx';
import Styled from 'rsg-components/Styled';

var styles = function styles(_ref) {
  var space = _ref.space;
  return {
    preContainer: {
      marginTop: 0,
      marginBottom: space[2]
    }
  };
};

/**
 * This is a container for the interactive playground and static code examples,
 * so we render it using the <div> element. The <pre> element will be added by
 * the MdxCode component in the appropriate place.
 */
export var MdxPre = function MdxPre(_ref2) {
  var classes = _ref2.classes,
      className = _ref2.className,
      children = _ref2.children;
  var classNames = cx(className, classes.preContainer);
  return /*#__PURE__*/React.createElement("div", {
    className: classNames
  }, children);
};
MdxPre.propTypes = {
  classes: PropTypes.objectOf(PropTypes.string.isRequired).isRequired,
  className: PropTypes.string,
  children: PropTypes.node
};
export default Styled(styles)(MdxPre);