import "core-js/modules/es.object.assign.js";

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React from 'react';
import { MDXProvider as MDXProviderBase } from '@mdx-js/react';
import Link from 'rsg-components/Link';
import Text from 'rsg-components/Text';
import Para from 'rsg-components/Para';
import MdxCode from 'rsg-components/mdx/MdxCode';
import MdxPre from 'rsg-components/mdx/MdxPre';
import MdxWrapper from 'rsg-components/mdx/MdxWrapper';
import MdxHeading from 'rsg-components/mdx/MdxHeading';
import MdxList from 'rsg-components/mdx/MdxList';
import MdxBlockquote from 'rsg-components/mdx/MdxBlockquote';
import MdxHr from 'rsg-components/mdx/MdxHr';
import MdxTable from 'rsg-components/mdx/MdxTable';
import MdxTableHead from 'rsg-components/mdx/MdxTableHead';
import MdxTableBody from 'rsg-components/mdx/MdxTableBody';
import MdxTableRow from 'rsg-components/mdx/MdxTableRow';
import MdxTableCell from 'rsg-components/mdx/MdxTableCell'; // TODO: Allow components customization via style guide config

var DEFAULT_COMPONENTS = {
  wrapper: MdxWrapper,
  a: Link,
  h1: function h1(props) {
    return /*#__PURE__*/React.createElement(MdxHeading, _extends({
      level: 1
    }, props));
  },
  h2: function h2(props) {
    return /*#__PURE__*/React.createElement(MdxHeading, _extends({
      level: 2
    }, props));
  },
  h3: function h3(props) {
    return /*#__PURE__*/React.createElement(MdxHeading, _extends({
      level: 3
    }, props));
  },
  h4: function h4(props) {
    return /*#__PURE__*/React.createElement(MdxHeading, _extends({
      level: 4
    }, props));
  },
  h5: function h5(props) {
    return /*#__PURE__*/React.createElement(MdxHeading, _extends({
      level: 5
    }, props));
  },
  h6: function h6(props) {
    return /*#__PURE__*/React.createElement(MdxHeading, _extends({
      level: 6
    }, props));
  },
  p: function p(props) {
    return /*#__PURE__*/React.createElement(Para, _extends({
      semantic: "p"
    }, props));
  },
  em: function em(props) {
    return /*#__PURE__*/React.createElement(Text, _extends({
      semantic: "em"
    }, props));
  },
  strong: function strong(props) {
    return /*#__PURE__*/React.createElement(Text, _extends({
      semantic: "strong"
    }, props));
  },
  ul: MdxList,
  ol: function ol(props) {
    return /*#__PURE__*/React.createElement(MdxList, _extends({
      ordered: true
    }, props));
  },
  blockquote: MdxBlockquote,
  code: MdxCode,
  pre: MdxPre,
  hr: MdxHr,
  table: MdxTable,
  thead: MdxTableHead,
  tbody: MdxTableBody,
  tr: MdxTableRow,
  td: MdxTableCell,
  th: function th(props) {
    return /*#__PURE__*/React.createElement(MdxTableCell, _extends({
      header: true
    }, props));
  }
};
export default function MdxProvider(_ref) {
  var children = _ref.children;
  return /*#__PURE__*/React.createElement(MDXProviderBase, {
    components: DEFAULT_COMPONENTS
  }, children);
}