import "core-js/modules/es.object.assign.js";
import React from 'react';
import getComponent from '../../utils/getComponent';
import MdxContext from './MdxContext';
export default function MdxWrapper(_ref) {
  var _ref2;

  var children = _ref.children,
      componentName = _ref.componentName,
      exampleMode = _ref.exampleMode,
      documentScope = _ref.__documentScope,
      exampleScope = _ref.__exampleScope,
      storiesScope = _ref.__storiesScope,
      currentComponent = _ref.__currentComponent,
      namedExamples = _ref.__namedExamples;
  var expandedDocumentScope = Object.assign({
    // Make React available to examples
    React: React
  }, currentComponent && componentName ? (_ref2 = {}, _ref2[componentName] = getComponent(currentComponent), _ref2) : {}, documentScope);
  var expandedExampleScope = Object.assign({}, exampleScope, storiesScope);
  return /*#__PURE__*/React.createElement(MdxContext.Provider, {
    value: {
      componentName: componentName,
      exampleMode: exampleMode,
      documentScope: expandedDocumentScope,
      exampleScope: expandedExampleScope,
      namedExamples: namedExamples
    }
  }, children);
}