function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import "core-js/modules/es.string.replace.js";
import "core-js/modules/es.regexp.exec.js";
import "core-js/modules/es.function.name.js";
import "core-js/modules/es.object.assign.js";
import "core-js/modules/es.object.keys.js";
import React from 'react';
import PropTypes from 'prop-types';
import camelCase from 'lodash/camelCase';
import Para from 'rsg-components/Para';
import PlaygroundError from 'rsg-components/PlaygroundError';
import Playground from 'rsg-components/Playground';
import { useMdxContext } from '../MdxContext';
import MdxHighlight from '../MdxHighlight';
import MdxCodeStatic from '../MdxCodeStatic';
// TODO: Extract to its own file?
// XXX: We're assuming that all imported stories are located in a .story.js file
// next to the Mdx file with the same name, so we're ignoring all but the very
// last part of the story ID, which is the name of the exported from the CSF file
// function
export var getLocalExampleNameById = function getLocalExampleNameById(id) {
  return camelCase(id.replace(/^.*?--/, ''));
};
export default function Story(_ref) {
  var id = _ref.id,
      name = _ref.name,
      modifiers = _objectWithoutPropertiesLoose(_ref, ["id", "name"]);

  var _useMdxContext = useMdxContext(),
      componentName = _useMdxContext.componentName,
      exampleMode = _useMdxContext.exampleMode,
      documentScope = _useMdxContext.documentScope,
      exampleScope = _useMdxContext.exampleScope,
      namedExamples = _useMdxContext.namedExamples;

  if (name) {
    return /*#__PURE__*/React.createElement(Para, null, /*#__PURE__*/React.createElement(PlaygroundError, {
      message: "Story: Only stories imported by ID are supported"
    }));
  }

  if (!id) {
    return /*#__PURE__*/React.createElement(Para, null, /*#__PURE__*/React.createElement(PlaygroundError, {
      message: "Story: Imported example ID is required"
    }));
  }

  var key = getLocalExampleNameById(id);
  var code = namedExamples == null ? void 0 : namedExamples[key];

  if (!code) {
    return /*#__PURE__*/React.createElement(Para, null, /*#__PURE__*/React.createElement(PlaygroundError, {
      message: "Story: Imported example `" + id + "` not found in a story file"
    }));
  }

  if (modifiers.static) {
    return /*#__PURE__*/React.createElement(MdxCodeStatic, null, /*#__PURE__*/React.createElement(MdxHighlight, null, code));
  }

  return /*#__PURE__*/React.createElement(Playground, {
    code: code,
    componentName: componentName || '' // TODO
    ,
    exampleMode: exampleMode,
    documentScope: documentScope,
    exampleScope: exampleScope,
    modifiers: Object.assign({}, modifiers, {
      index: key
    })
  });
}
Story.propTypes = {
  id: PropTypes.string.isRequired
};