import "core-js/modules/es.string.match.js";
import "core-js/modules/es.regexp.exec.js";
import "core-js/modules/es.string.trim.js";
// eslint-disable-next-line import/no-unresolved
import * as compiler from 'rsg-compiler';
import insertReturnLastExpression from './insertReturnLastExpression';

var startsWithJsx = function startsWithJsx(code) {
  return !!code.trim().match(/^</);
};

var wrapCodeInFragment = function wrapCodeInFragment(code) {
  return "<React.Fragment>" + code + "</React.Fragment>;";
};
/*
 * 1. Wrap code in React Fragment if it starts with JSX element
 * 2. Compile code using given compiler
 * 3. Wrap the last top-level expression in a return statement.
 */


export default function compileCode(code, compileExample, onError) {
  var wrappedCode = startsWithJsx(code) ? wrapCodeInFragment(code) : code;

  try {
    var compiledCode = compileExample(compiler, wrappedCode);
    return insertReturnLastExpression(compiledCode);
  } catch (err) {
    if (onError) {
      onError(err);
    }

    return '';
  }
}