import "core-js/modules/es.string.split.js";
import "core-js/modules/es.regexp.exec.js";
import { hasInHash, getHashAsArray } from './handleHash';
/**
 * Returns an object containing component/section name and, optionally, an example index
 * from hash part or page URL:
 * #!/Button → { targetName: 'Button' }
 * #!/Button//1 → { targetName: 'Button', targetIndex: 1 }
 * #!/Button//basic → { targetName: 'Button', targetIndex: 'basic' }
 */

export default function getInfoFromHash(hash) {
  var shouldIsolate = hasInHash(hash, '#!/');

  if (shouldIsolate || hasInHash(hash, '#/')) {
    var _hash$split = hash.split('//'),
        baseHash = _hash$split[0],
        targetHash = _hash$split[1];

    var hashArray = getHashAsArray(baseHash, shouldIsolate ? '#!/' : '#/');
    return {
      isolate: shouldIsolate,
      hashArray: hashArray,
      targetName: hashArray[0],
      targetIndex: parseInt(targetHash, 10) || targetHash
    };
  }

  return {};
}