import "core-js/modules/es.array.map.js";
import "core-js/modules/es.object.assign.js";
import getUrl from './getUrl';

/**
 * Do things that are hard or impossible to do in a loader: we don’t have access to component name
 * and props in the styleguide-loader because we’re using `require` to load the component module.
 */
export default function processComponents(components, _ref) {
  var useRouterLinks = _ref.useRouterLinks,
      useHashId = _ref.useHashId,
      hashPath = _ref.hashPath;
  return components.map(function (component) {
    return component.props ? Object.assign({}, component, {
      // Add .name shortcuts for names instead of .props.displayName.
      name: component.props.displayName,
      visibleName: component.props.visibleName || component.props.displayName,
      href: component.href || getUrl({
        name: component.props.displayName,
        slug: component.slug,
        anchor: !useRouterLinks,
        hashPath: useRouterLinks ? hashPath : false,
        useSlugAsIdParam: useRouterLinks ? useHashId : false
      })
    }) : {};
  });
}