"use strict";

exports.__esModule = true;
exports.default = void 0;

var _unistUtilVisit = _interopRequireDefault(require("unist-util-visit"));

var _escodegen = require("escodegen");

var _toAst = _interopRequireDefault(require("to-ast"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// TODO: deduplicate
const getCodeValue = node => node.children[0].type === 'text' ? String(node.children[0].value) : ''; // TODO: deduplicate


const getCodeLang = node => {
  var _node$properties$clas, _node$properties$clas2;

  return ((_node$properties$clas = node.properties.className) == null ? void 0 : (_node$properties$clas2 = _node$properties$clas.find(s => s.startsWith('language-'))) == null ? void 0 : _node$properties$clas2.replace(/^language-/, '')) || '';
};

const getAllExamples = tree => {
  const examples = [];
  (0, _unistUtilVisit.default)(tree, {
    type: 'element',
    tagName: 'code'
  }, node => {
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    const {
      className,
      metastring,
      ...modifiers
    } = node.properties;
    examples.push({
      content: getCodeValue(node),
      lang: getCodeLang(node),
      settings: modifiers
    });
  });
  return examples;
};
/**
 * Generate export with all code examples.
 *
 * ```jsx noeditor
 * <Button />
 * ```
 *
 * ->
 *
 * export const __examples = [
 *   {content: '<Button />', lang: 'jsx', settings: {noeditor: true}}
 * ]
 */


var _default = () => treeRaw => {
  const tree = treeRaw;
  const examples = getAllExamples(tree); // Generate export

  const exportCode = `export const __examples = ${(0, _escodegen.generate)((0, _toAst.default)(examples))}`;
  tree.children.push({
    type: 'export',
    value: exportCode
  });
  return tree;
};

exports.default = _default;