import { Parent, Node as MdxNode } from 'unist';
declare const _default: ({ componentPath, mdxDocumentPath, }: {
    componentPath: string;
    mdxDocumentPath: string;
}) => () => (treeRaw: MdxNode) => Parent;
/**
 * Reexport stories from a CSF file via webpack loader (to enable hot reload).
 *
 * import Button from './Button'
 * import Container from './Container'
 * export const basic = () => <Container><Button /></Container>
 *
 * ->
 *
 * import { __stories_namedExamples, __stories_storiesScope } from '!!...'
 * export const __namedExamples = __stories_namedExamples;
 * export const __storiesScope = __stories_storiesScope;
 */
export default _default;
