"use strict";

exports.__esModule = true;
exports.default = void 0;

var _unistUtilVisit = _interopRequireDefault(require("unist-util-visit"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const PLAYGROUND_LANGS = ['javascript', 'js', 'jsx', 'typescript', 'ts', 'tsx'];

const getCodeLang = node => {
  var _node$properties$clas, _node$properties$clas2;

  return ((_node$properties$clas = node.properties.className) == null ? void 0 : (_node$properties$clas2 = _node$properties$clas.find(s => s.startsWith('language-'))) == null ? void 0 : _node$properties$clas2.replace(/^language-/, '')) || '';
};
/**
 * Add the `static` modifier to each code example that shouldn't be rendered
 * as a dynamic playgound
 */


var _default = () => tree => {
  (0, _unistUtilVisit.default)(tree, {
    type: 'element',
    tagName: 'code'
  }, node => {
    const lang = getCodeLang(node);

    if (!PLAYGROUND_LANGS.includes(lang)) {
      node.properties.static = true;
    }
  });
  return tree;
};

exports.default = _default;