"use strict";

exports.__esModule = true;
exports.default = void 0;

const getLocalName = () => `__ex_component`;
/**
 * Bundle the current component, and add an export statement with the component
 * module.
 *
 * import * as __ex_component from './Button'
 * export const __currentComponent = __ex_component
 */


var _default = ({
  componentPath
}) => () => treeRaw => {
  const tree = treeRaw; // Generate import

  tree.children.push({
    type: 'import',
    value: `import * as ${getLocalName()} from '${componentPath}'`
  }); // Generate export

  const exportCode = `export const __currentComponent = ${getLocalName()}`;
  tree.children.push({
    type: 'export',
    value: exportCode
  });
  return tree;
};

exports.default = _default;