import { Parent, Node } from 'unist';
import * as Rsg from '../../typings';
declare const _default: ({ context }: {
    context: Rsg.SanitizedStyleguidistConfig['context'];
}) => () => (treeRaw: Node) => Parent;
/**
 * 1. Add import statements for all context modules — modules provied by the
 *    user in the style guide config
 * 2. Add an export statement with a map with all imported into an Mdx document
 *    modules, and context modules:
 *
 * import Button from './Button'
 * import Input from './Input'
 *
 * ->
 *
 * ...
 * export const __documentScope = {'Button': Button, 'Input': Input}
 */
export default _default;
