"use strict";

exports.__esModule = true;
exports.default = void 0;

var _unistUtilVisit = _interopRequireDefault(require("unist-util-visit"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// TODO: Deduplicate, we have the same in markStaticExamples
const getCodeLang = node => {
  var _node$properties$clas, _node$properties$clas2;

  return ((_node$properties$clas = node.properties.className) == null ? void 0 : (_node$properties$clas2 = _node$properties$clas.find(s => s.startsWith('language-'))) == null ? void 0 : _node$properties$clas2.replace(/^language-/, '')) || undefined;
};

const getCode = node => node.children[0].type === 'text' ? node.children[0].value : '';
/**
 * Update examples in fenced code blocks using the `updateExample()` function from
 * the style guide config
 */


var _default = ({
  updateExample,
  mdxDocumentPath
}) => () => tree => {
  (0, _unistUtilVisit.default)(tree, {
    type: 'element',
    tagName: 'code'
  }, node => {
    const content = getCode(node);
    const lang = getCodeLang(node);
    const {
      className,
      metastring,
      ...settings
    } = node.properties;
    const nextExample = updateExample({
      content,
      lang,
      settings
    }, mdxDocumentPath); // TODO: Update lang

    node.children[0].value = nextExample.content.trim();
    node.properties = { ...nextExample.settings,
      className,
      metastring
    };
  });
  return tree;
};

exports.default = _default;