import { loader } from 'webpack';
/**
 * 1. Generate export with all modules imported into a Component Story Format
 *    (CSF) file, so they are available in examples when we run them.
 * 2. Generate export with all strories in a CSF files.
 * 3. Generate imports for all modules imported by a CSF file so weback bundles
 *    the modules.
 * 4. Prepend each story example with necessary imports and local variables.
 *
 * import Button from './Button'
 * import Container from './Container'
 * export const basic = () => <Container><Button /></Container>
 *
 * ->
 *
 * import * as __stories_import_0 from './Button'
 * export const __stories_namedExamples = {
 *   basic: 'import Button from './Button'\n\n<Container><Button /></Container>'
 * }
 * export const __stories_storiesScope = {
 *   './Button': __stories_import_0
 * }
 */
export default function storiesLoader(this: loader.LoaderContext, storiesCode: string): void;
