"use strict";

exports.__esModule = true;
exports.default = compileCode;

var compiler = _interopRequireWildcard(require("rsg-compiler"));

var _insertReturnLastExpression = _interopRequireDefault(require("./insertReturnLastExpression"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function () { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

// eslint-disable-next-line import/no-unresolved
const startsWithJsx = code => !!code.trim().match(/^</);

const wrapCodeInFragment = code => `<React.Fragment>${code}</React.Fragment>;`;
/*
 * 1. Wrap code in React Fragment if it starts with JSX element
 * 2. Compile code using given compiler
 * 3. Wrap the last top-level expression in a return statement.
 */


function compileCode(code, compileExample) {
  const wrappedCode = startsWithJsx(code) ? wrapCodeInFragment(code) : code;
  const compiledCode = compileExample(compiler, wrappedCode);
  return (0, _insertReturnLastExpression.default)(compiledCode);
}