"use strict";

exports.__esModule = true;
exports.default = getAllContentPages;

/**
 * Get all section content pages
 */
function getAllContentPages(sections) {
  return sections.reduce((pages, section) => {
    if (section.content) {
      pages = [...pages, section.content];
    }

    if (section.sections) {
      pages = [...pages, ...getAllContentPages(section.sections)];
    }

    return pages;
  }, []);
}