"use strict";

exports.__esModule = true;
exports.default = getExamples;

var _path = _interopRequireDefault(require("path"));

var _fs = _interopRequireDefault(require("fs"));

var _qss = require("qss");

var _requireIt = _interopRequireDefault(require("./requireIt"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const mdxLoader = _path.default.resolve(__dirname, '../mdx-loader.js');
/**
 * Get require statement for examples file if it exists.
 */


function getExamples(file, examplesFile) {
  const examplesFileToLoad = examplesFile && _fs.default.existsSync(examplesFile) ? examplesFile : false;

  if (!examplesFileToLoad) {
    return undefined;
  }

  const component = `./${_path.default.relative(_path.default.dirname(examplesFileToLoad), file)}`;
  const query = {
    component
  };
  return (0, _requireIt.default)(`!!${mdxLoader}?${(0, _qss.encode)(query)}!${examplesFileToLoad}`);
}