/// <reference types="webpack-dev-server" />
import { Configuration } from 'webpack';
declare type Mode = Configuration['mode'];
declare type MetaConfig = Configuration | ((env: Mode) => Configuration);
/**
 * Merge two Webpack configs.
 *
 * In the user config:
 * - Ignores given sections (options.ignore).
 * - Ignores plugins that shouldn’t be used twice or may cause issues.
 *
 * @param baseConfig
 * @param userConfig
 * @param env
 */
export default function mergeWebpackConfig(baseConfig: Configuration, userConfig: MetaConfig, env?: Mode): Configuration;
export {};
